/*
** s_list.h for list in /u/a1/lefebv_t
**
** Made by tony lefebvre
** Login   <lefebv_t@epita.fr>
**
** Started on  Fri Sep 16 21:18:18 2005 tony lefebvre
** Last update Fri Nov  4 21:57:31 2005 charles-alban deledalle
*/

#ifndef S_LIST_H_
# define S_LIST_H_

struct             s_list
{
  struct s_list   *next;
  void            *data;
};

typedef int	(*t_cmp_func)(const void *, const void*);
typedef void	(*t_display_func)(const void *);
typedef void	(*t_free_func)(void *);

struct s_list	*list_create_node(void *data);
void		list_add_item_end(struct s_list **list, void *data);
unsigned int	list_size(const struct s_list *list);
void		list_add_item_head(struct s_list **list, void *data);
void		list_show(const struct s_list	*list,
			  t_display_func	display_func);
void		list_show_str(const struct s_list *list);
void		list_free(struct s_list **list, t_free_func free_func);
void		*list_find_item_eq(const struct s_list	*list,
				   const void		*data,
				   t_cmp_func		cmp_func);
void		list_concat(struct s_list	**list_a,
			    struct s_list	*list_b);
void		list_shift(struct s_list **list);
void		*list_delete_item(struct s_list	**list,
				  const void	*data,
				  t_cmp_func	cmp_func);
void		list_add_item_sorted(struct s_list **list,
				     void		*data,
				     t_cmp_func		cmp_func);
void		list_rev(struct s_list **list);
void		list_sort(struct s_list **list, t_cmp_func cmp_func);
void		list_merge(struct s_list	**list_a,
			   struct s_list	*list_b,
			   t_cmp_func           cmp_func);

#endif /* ! S_LIST_H_ */
